<?php

namespace GraphikDimensions\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Process ServiceType
 * @subpackage Services
 * @date Generated 2017-02-10
 * @author https
 */
class Process extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named processOrder
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \GraphikDimensions\StructType\ProcessOrder $parameters
     * @return \GraphikDimensions\StructType\ProcessOrderResponse|bool
     */
    public function processOrder(\GraphikDimensions\StructType\ProcessOrder $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->processOrder($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named processCoupon
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \GraphikDimensions\StructType\ProcessCoupon $parameters
     * @return \GraphikDimensions\StructType\ProcessCouponResponse|bool
     */
    public function processCoupon(\GraphikDimensions\StructType\ProcessCoupon $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->processCoupon($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named processFramerOrder
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \GraphikDimensions\StructType\ProcessFramerOrder $parameters
     * @return \GraphikDimensions\StructType\ProcessFramerOrderResponse|bool
     */
    public function processFramerOrder(\GraphikDimensions\StructType\ProcessFramerOrder $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->processFramerOrder($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \GraphikDimensions\StructType\ProcessCouponResponse|\GraphikDimensions\StructType\ProcessFramerOrderResponse|\GraphikDimensions\StructType\ProcessOrderResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
